# CATEGORIA[scarpe(0), pantaloni(1), maglia(2), cappello(3)]
# STAGIONE[primavera(p),estate(e),autunno(a),inverno(i)]
# descrizione: massimo 64 caratteri (64 byte)
# colore: massimo 6 caratteri (6 byte)
# CAMPO[categoria(offset 0 byte), colore(offset 1 byte), stagione(offset 7 byte), descrizione(offset 8 byte)]
.data
# dimensione A[] 16 elementi, da A_00 a A_15
A: .word A_00, A_01, A_02, A_03, A_04, A_05, A_06, A_07, A_08, A_09, A_10, A_11, A_12, A_13, A_14, A_15
# xx_A[tipo(1 byte) + colore(6 byte) + stagione(1 byte) + descrizione(64 byte)] = 72 byte
A_00: .space 72
A_01: .space 72
A_02: .space 72
A_03: .space 72
A_04: .space 72
A_05: .space 72
A_06: .space 72
A_07: .space 72
A_08: .space 72
A_09: .space 72
A_10: .space 72
A_11: .space 72
A_12: .space 72
A_13: .space 72
A_14: .space 72
A_15: .space 72
.align 2
B: .word B_00, B_01, B_02, B_03, B_04, B_05, B_06, B_07, B_08, B_09, B_10, B_11, B_12, B_13, B_14, B_15
# xx_B[tipo(1 byte) + colore(6 byte) + stagione(1 byte) + descrizione(64 byte)] = 72 byte
B_00: .space 72
B_01: .space 72
B_02: .space 72
B_03: .space 72
B_04: .space 72
B_05: .space 72
B_06: .space 72
B_07: .space 72
B_08: .space 72
B_09: .space 72
B_10: .space 72
B_11: .space 72
B_12: .space 72
B_13: .space 72
B_14: .space 72
B_15: .space 72
.align 2
# si ipotizza un seed random fornito dal sistema operativo, in questo caso inizializzato come costante #
seed: .word 0x48235697	# allocamento in memoria e assegnazione del valore iniziale a seed della funzione random()
buffer_str: .space 65
.align 2
cerca_k: .space 64	# spazio in memoria adibito al passaggio del parametro da cercare
cerca_k_stagione: .space 1	# spazio in memoria adibito al passaggio del parametro da cercare
cerca_k_categoria: .space 1	# spazio in memoria adibito al passaggio del parametro da cercare
.align 2
menu_jat: .word menu_inserisci,menu_stampa,menu_elimina,menu_filtra,menu_casuale,menu_esci
menu_filtra_campo_jat: .word menu_filtra_categoria,menu_filtra_colore,menu_filtra_stagione,menu_filtra_descrizione
menu_cerca_campo_jat: .word menu_cerca_categoria,menu_cerca_colore,menu_cerca_stagione,manu_cerca_descrizione
cerca_campo_jat: .word cerca_categoria,cerca_colore,cerca_stagione,cerca_descrizione
str_menu: .asciiz "\ninserire il numero corrispondente all'operazione che si desidera effettuare:
0 - inserisci nuovi elementi
1 - visualizza tutti gli elementi
2 - cancella elemento tramite id
3 - filtra elementi da visualizzare
4 - visualizza una combinazione casuale in base agli elementi scelti
5 - esci
"
str_menu_errore: .asciiz "\nSelezione non valida, riprovare.\n"
str_menu_campo: .asciiz "\nInserire il numero corrispondente al campo in cui si desidera effettuare la ricerca
0 - categoria
1 - colore
2 - stagione
3 - descrizione
"
str_elimina_id: .asciiz "\nInserire l'id dell'oggetto da eliminare:\n"
str_elimina_id_errore: .asciiz "\nId errato\n"
str_filtra_colore: .asciiz "\nInserire colore, si ricorda che deve corrispondere esattamente al colore inserito al momento dell'inserimento in database: "
str_filtra_descrizione: .asciiz "\nInserire descrizione, si ricorda che deve corrispondere esattamente alla descrizione inserita al momento dell'inserimento in database: "
str_casuale_combinazioni: .asciiz "\nNumero di combinazioni possibili: "
str_casuale_next: .asciiz "\nPremere \"s\" per vedere un'altra combinazione o qualunque altro tasto per tornare al menu: "
str_inserisci_n: .asciiz "\nQuanti elementi vuoi inserire? "
str_inserisci_errore: .asciiz "\nNon c'è abbastanza spazio. Massimo 16 capi.\n"
str_inserisci_categoria: .asciiz "\nInserisci categoria tra\ns = scarpe\np = pantaloni\nm = maglia\nc = cappello\n"
str_inserisci_colore: .asciiz "\nInserisci colore (max 6 caratteri): "
str_inserisci_stagione: .asciiz "\nInserisci stagione tra\ne = estate\na = autunno\ni = inverno\np = primavera\n"
str_inserisci_descrizione: .asciiz "\nInserisci descrizione (max 64 caratteri): "
str_casuale_inserisci_colore: .asciiz "\nInserisci colore (max 6 caratteri) o INVIO per selezionare tutti i colori: \n"
str_casuale_inserisci_stagione: .asciiz "\nInserisci stagione tra\ne = estate\na = autunno\ni = inverno\np = primavera\noppure INVIO per selezionarle tutte\n"
str_intestazione: .asciiz "\nid | categoria | colore | stagione | descrizione\n-------------------------------------------------\n"
str_separatore: .asciiz " | "

.text
main:
	la $s0, A						# s0 <- &A[]
	li $s1, 0						# s1 <- N = 0
menu:
	li $v0, 4						# seleziono print_string
	la $a0, str_menu					# seleziono stringa str_menu
	syscall							# chiamo print_string(str_menu)
	li $v0, 5						# seleziono read_int
	syscall							# case <- read_int()
	slt $t0, $v0, $zero					# se(case < 0) t0 <- 1 altrimenti t0 <- 0
	bne $t0, $zero, menu_errore		 		# se(t0!=0) ovvero se(case < 0) vai a menu_errore
	slti $t0, $v0, 8					# se(case < 6) t0 <- 1 altrimenti t0 <- 0
	beq $t0, $zero, menu_errore				# se(t0==0) ovvero se(case >= 8) vai a menu_errore
	
	la $t0, menu_jat					# t0 <- &menu_jat[] (menu jump address table)
	sll $t1, $v0, 2						# t1 <- case * 4
	add $t1, $t0, $t1					# t1 <- &menu_jat[case] = &menu_jat[] + case * 4
	lw $t1, 0($t1)						# t1 <- menu_jat[case]
	jr $t1							# vai a indirizzo in menu_jat[case]

	menu_inserisci:
		move $a0, $s0						# a0 <- &A[]
		move $a1, $s1						# a1 <- N
		jal inserisci						# chiamo inserisci(A[],N)
		move $s1, $v0						# s1 <- nuovo N restituito da inserisci()
		j menu							# torna al menu
	menu_stampa:
		move $a0, $s0						# a0 <- &A[]
		move $a1, $s1						# a1 <- N
		jal stampa						# chiamo stampa(A[],N)
		j menu							# torna al menu
	menu_elimina:
		move $a0, $s0						# a0 <- &A[]
		move $a1, $s1						# a1 <- N
		jal elimina						# chiamo cancella(A[],N)
		move $s1, $v0						# N <- nuvo_N = N-1
		j menu							# torna al menu
	menu_filtra:
		jal pulisci_cerca_k					# chiamo pulisci_cerca_k()
		la $t2, cerca_k						# t2 <- &cerca_k
		li $v0, 4						# seleziono print_string
		la $a0, str_menu_campo					# scelgo di stampare str_menu_campo
		syscall							# chiamo print_string(str_menu_campo)
		li $v0, 5						# seleziono read_int
		syscall							# chiamo read_int()
		move $s2, $v0						# s2 <- campo/case
		
		slt $t0, $s2, $zero					# se(campo < 0) t0 <- 1 altrimenti t0 <- 0
		bne $t0, $zero, filtra_campo_errore		 	# se(t0!=0) ovvero se(campo < 0) vai a menu_errore
		slti $t0, $s2, 4					# se(campo < 4) t0 <- 1 altrimenti t0 <- 0
		beq $t0, $zero, filtra_campo_errore			# se(t0==0) ovvero se(campo >= 4) vai a menu_errore

		la $t0, menu_filtra_campo_jat				# t0 <- &filtra_campo_jat[] (jump address table)
		sll $t1, $v0, 2						# t1 <- case * 4
		add $t0, $t0, $t1					# t1 <- &menu_jat[case] = &menu_jat[] + case * 4
		lw $t0, 0($t0)						# t1 <- menu_jat[case]
		jr $t0							# vai a indirizzo in filtra_campo_jat[case]
		menu_filtra_categoria:
			li $v0, 4						# seleziono print_string
			la $a0, str_inserisci_categoria				# selezioni stringa str_inserisci_categoria
			syscall							# chiamo print_string(str_inserisci_categoria)
			li $v0, 12						# seleziono read_char
			syscall							# chiamo read_char()
			sw $v0, 0($t2)						# cerca_k[] <- k da cercare
			j chiama_filtra
		menu_filtra_colore:
			li $v0, 4						# seleziono print_string
			la $a0, str_filtra_colore				# selezioni stringa str_filtra_colore
			syscall							# chiamo print_string(str_filtra_colore)
			la $a0, buffer_str					# seleziono buffer_str
			li $v0, 8						# seleziono read_string
			li $a1, 8						# leggo 8 caratteri
			syscall							# chiamo read_string
			la $t6, buffer_str					# t6 <- &buffer_str
			li $t4, 0						# t4 <- j = 0
			ciclo_menu_filtra_colore:				# for(j=0, j<6, j++)
				slti $t7, $t4, 6					# se(j < 6) t7 <- 1 altrimenti t7 <- 0
				beq $t7, $zero, chiama_filtra				# se(t7==0), ovvero se(j>=6) vai a fine_ciclo
				add $t0, $t6, $t4					# t0 <- &buffer_str + j
				lb $t3, 0($t0)						# leggo j-esimo carattere da buffer_str
				add $t0, $t2, $t4					# t0 <- &cerca_k + j
				beq $t3, 0x0a, menu_filtra_colore_return		# se il char letto equivale a 0x0a(return) vai a filtra_colore_return
				sb $t3, 0($t0)						# scrivo j-esimo carattere in cerca_k
				addi $t4, $t4, 1					# j++
			j ciclo_menu_filtra_colore
			menu_filtra_colore_return:
				sb $zero, 0($t0)					# scrivo j-esimo carattere
				j chiama_filtra					# vai a chiama_filtra
		menu_filtra_stagione:
			li $v0, 4						# seleziono print_string
			la $a0, str_inserisci_stagione				# selezioni stringa str_inserisci_stagione
			syscall							# chiamo print_string(str_inserisci_stagione)
			li $v0, 12						# seleziono read_char
			syscall							# chiamo read_char()
			sw $v0, 0($t2)						# cerca_k[] <- k da cercare
			j chiama_filtra
		menu_filtra_descrizione:
			li $v0, 4						# seleziono print_string
			la $a0, str_filtra_descrizione				# selezioni stringa str_filtra_descrizione
			syscall							# chiamo print_string(str_filtra_descrizione)
			li $v0, 8						# seleziono read_string
			la $a0, buffer_str					# seleziono buffer_str
			li $a1, 65						# leggo 64 caratteri
			syscall							# chiamo read_string
			li $t4, 0						# t4 <- j = 0
			la $t6, buffer_str					# t6 <- &buffer_str
			ciclo_menu_filtra_descrizione:				# for(j=0, j<16, j++)
				slti $t7, $t4, 16					# se(j < 16) t7 <- 1 altrimenti t7 <- 0
				beq $t7, $zero, chiama_filtra				# se(t7==0), ovvero se(j>=16) vai a fine_ciclo
				sll $t1, $t4, 2						# t1 <- offset(j) = j * 4
				add $t0, $t6, $t1					# t0 <- &buffer_str + offset(j)
				lw $t3, 0($t0)						# leggo j-esimi 4 caratteri dal buffer
				add $t0, $t2, $t1					# t0 <- &cerca_k + offset(j)
				sw $t3, 0($t0)						# scrivo j-esimi 4 caratteri in cerca_k[]
				addi $t4, $t4, 1					# j++
			j ciclo_menu_filtra_descrizione
		filtra_campo_errore:
			li $v0, 4						# seleziono print_string
			la $a0, str_menu_errore					# seleziono stringa str_menu_errore
			syscall							# chiamo print_string(str_menu_errore)
			j menu_filtra						# torna a menu_filtra per selezionare un campo valido
		chiama_filtra:
			move $a0, $s0						# a0 <- &A[]
			move $a1, $s1						# a1 <- N
			move $a2, $s2						# a2 <- campo
			li $a3, 0						# a3 <- i = 0
			addi $sp, $sp, -4
			sw $t2, 0($sp)						# stack[&cerca_k]
			jal filtra						# chiamo filtra(A[],N,campo,i,&cerca_k)
			move $a0, $v0						# a0 <- B[] = array restituito da filtra()
			move $a1, $v1						# a1 <- M = dimensione array restituito da filtra()
			jal stampa						# chiamo stampa(B[],M)
			j menu
	menu_casuale:
		move $a0, $s0						# a0 <- &A[]
		move $a1, $s1						# a1 <- N
		jal casuale						# chiamo casuale(A[],N)
		j menu
	menu_errore:
		li $v0, 4						# seleziono print_string
		la $a0, str_menu_errore					# seleziono stringa str_menu_errore
		syscall							# chiamo print_string(str_menu_errore)
		j menu							# torna al menu
	menu_esci:
		li $v0, 10						# seleziono exit
		syscall							# chiamo exit()
##########################################################################
pulisci_cerca_k:
la $t2, cerca_k					# t2 <- &cerca_k
la $t3, buffer_str				# t3 <- &buffer_str
li $t0, 0						# t0 <- i = 0
ciclo_pulisci_cerca_k:					# for(i=0,i<16,i++)
	slti $t1, $t0, 16					# se(i<16) t1 <- 1 altrimenti t1 <- 0
	beq $t1, $zero, fine_ciclo_pulisci_cerca_k		# se(t1==0) ovvero se(i>=16) vai a fine_ciclo...
	sll $t1, $t0, 2						# t1 <- offset(i) = i * 4
	add $t4, $t2, $t1					# t4 <- &cerca_k[i] = &cerca_k + offset(i)
	sw $zero, 0($t4)					# cerca_k[i] <- zero
	add $t4, $t3, $t1					# t4 <- &buffer_str[i] = &buffer_str + offset(i)
	sw $zero, 0($t4)					# buffer_str[i] <- zero
	addi $t0, $t0, 1					# i++
j ciclo_pulisci_cerca_k
fine_ciclo_pulisci_cerca_k:
jr $ra
#########################################################################################################################
# N inserisci(A[], N)
inserisci:
	# push
	addi $sp, $sp, -24
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)
	sw $s3, 12($sp)
	sw $s4, 16($sp)
	sw $ra, 20($sp)

	move $s0, $a0						# s0 <- $s0[]
	move $s1, $a1						# s1 <- N
	li $v0, 4						# seleziono print_string
	la $a0, str_inserisci_n					# seleziona stringa str_inserisci_n
	syscall							# chiamo print_string(str_inserisci_n)
	li $v0, 5						# seleziono read_int
	syscall							# chiamo read_int()
	move $t8, $v0						# t8 <- n
	add $s3, $s1, $t8					# s3 <- nuovo_N = N + n
	addi $t1, $s3, -16					# t1 <- nuovo_N - 16(MAX elementi consentiti)
	bgtz $t1, errore_inserisci				# se(nuvo_N - MAX > 0) ovvero se(nuvo_N > MAX) vai a errore_inserisci, altrimenti ...
		move $s2, $s1						# s2 <- i = N
		ciclo_inserisci:					# for(i=0,i<nuovo_N,i++)
			slt $t2, $s2, $s3					# se(i<nuovo_N) t2 <- 1 altrimenti t2 <- 0
			beq $t2, $zero, fine_inserisci				# se(i>=nuovo_N) vai a fine_inserisci, altrimenti...
			sll $t2, $s2, 2						# t2 <- offset = i * 4
			add $t2, $s0, $t2					# t2 <- &A[i][] = &A[][] +  offset
			lw $s4, 0($t2)						# s4 <- &A[i][categoria]
			# inserimento categoria
			li $v0, 4						# seleziono print_string
			la $a0, str_inserisci_categoria				# selezioni stringa str_inserisci_categoria
			syscall							# chiamo print_string(str_inserisci_categoria)
			li $v0, 12						# seleziono read_char
			syscall							# chiamo read_char()
			sb $v0, 0($s4)						# A[i][categoria] <- char
			# inserimento colore
			jal pulisci_cerca_k					# chiamo pulisci_cerca_k()
			li $v0, 4						# seleziono print_string
			la $a0, str_inserisci_colore				# selezioni stringa str_inserisci_colore
			syscall							# chiamo print_string(str_inserisci_colore)
			addi $s4, $s4, 1					# s4 <- &A[i][colore] = &A[i][categoria] + offset(1)
			li $v0, 8						# seleziono read_string
			la $a0, buffer_str					# seleziono buffer_str
			li $a1, 8						# leggo 8 char di cui 7° return e 8° fine stringa
			syscall							# chiamo read_string
			li $t4, 0						# t4 <- j = 0
			ciclo_colore_inserisci:					# for(j=0, j<M, j++)
				slti $t7, $t4, 6					# se(j < 6) t7 <- 1 altrimenti t7 <- 0
				beq $t7, $zero, fine_ciclo_colore_inserisci		# se(t7==0), ovvero se(j>=6) vai a fine_ciclo
				add $t6, $a0, $t4					# t6 <- &buffer_str[j-esimo_char] = &buffer_str[] + j
				lb $t3, 0($t6)						# t3 <- buffer_str[j-esimo_char]
				add $t7, $s4, $t4					# t7 <- &A[i][j-esimo_char_colore] = &A[i][colore] + j
				beq $t3, 0x0a, inserisci_colore_return			# se il char letto equivale a 0x0a(return) vai a inserisci_colore_return
				sb $t3, 0($t7)						# A[i][j-esimo_char_colore] <- buffer_str[j-esimo_char]
				addi $t4, $t4, 1					# j++
			j ciclo_colore_inserisci
				inserisci_colore_return:
					sb $zero, 0($t7)				# A[i][j-esimo_char_colore_] <- zero
			fine_ciclo_colore_inserisci:
			# inserimento stagione
			addi $s4, $s4, 6					# s4 <- &A[i][stagione] = &A[i][colore] + offset(6)
			li $v0, 4						# seleziono print_string
			la $a0, str_inserisci_stagione				# selezioni stringa str_inserisci_stagione
			syscall							# chiamo print_string(str_inserisci_stagione)
			li $v0, 12						# seleziono read_char
			syscall							# chiamo read_char()
			sb $v0, 0($s4)						# A[i][stagione] <- char
			# inserimento descrizione
			jal pulisci_cerca_k					# chiamo pulisci_cerca_k()
			addi $s4, $s4, 1					# s4 <- &A[i][descrizione] = &A[i][stagione] + offset(1)
			li $v0, 4						# seleziono print_string
			la $a0, str_inserisci_descrizione			# selezioni stringa str_inserisci_descrizione
			syscall							# chiamo print_string(str_inserisci_descrizione)
			li $v0, 8						# seleziono read_string
			la $a0, buffer_str					# seleziono buffer_str
			li $a1, 65						# leggo 64 caratteri
			syscall							# chiamo read_string
			li $t4, 0						# t4 <- j = 0
			ciclo_descrizione_inserisci:				# for(j=0, j<6, j++)
				slti $t7, $t4, 16					# se(j < 16) t7 <- 1 altrimenti t7 <- 0
				beq $t7, $zero, fine_ciclo_descrizione_inserisci	# se(t7==0), ovvero se(j>=16) vai a fine_ciclo
				sll $t6, $t4, 2						# t6 <- offset(j) = j * 4
				add $t7, $a0, $t6					# t7 <- &buffer_str[j-esima_word]
				lw $t3, 0($t7)						# t3 <- buffer_str[j-esima_word]
				add $t7, $s4, $t6					# t7 <- &A[i][j-esima_word_descrizione]
				sw $t3, 0($t7)						# A[i][j-esima_word_descrizione] <- buffer_str[j-esima_word]
				addi $t4, $t4, 1					# j++
			j ciclo_descrizione_inserisci
			fine_ciclo_descrizione_inserisci:
		addi $s2, $s2, 1 					# i++
		j ciclo_inserisci
errore_inserisci:
	li $v0, 4						# seleziono print_string
	la $a0, str_inserisci_errore				# seleziono sring str_inserisci_errore
	syscall							# chiamo print_string(str_inserisci_errore)
	move $s3, $s1
fine_inserisci:
	move $v0, $s3
	# pop
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	lw $s3, 12($sp)
	lw $s4, 16($sp)
	lw $ra, 20($sp)
	addi $sp, $sp, 24
	jr $ra
###########################################################################################################
# void stampa(A[], N)
stampa:
	move $t0, $a0					# t0 <- &A[]
	move $t1, $a1					# t1 <- N
	li $v0, 4					# seleziono print_string
	la $a0, str_intestazione			# seleziono stringa str_intestazione
	li $t2, 0					# t2 <- i=0
	syscall						# chiamo print_string(str_intestazione)
	ciclo_stampa:					# for(i=0, i<N, i++)
	slt $t3, $t2, $t1				# se(i<N) t3 <- 1 altrimenti t3 <- 0
	beq $t3, $zero, fine_stampa			# se(t3==0) ovvero se(i>=N) vai a fine_stampa
		sll $t3, $t2, 2					# t3 <- offset = i * 4
		add $t3, $t3, $t0				# t3 <- &A[] + offset
		lw $t3, 0($t3)					# t3 <- A[i] = &A[i][]
		# stampa indice	
		li $v0, 1					# seleziono print_int
		move $a0, $t2					# scelgo di stampare i
		syscall						# chiamo print_int(i)
		# stampa separatore
		li $v0, 4					# seleziono print_string
		la $a0, str_separatore				# seleziono stringa str_separatore
		syscall						# chiamo print_string(str_separatore)
		# stampa A[i][categoria]
		li $v0, 11					# seleziono print_char
		lb $a0, 0($t3)					# scelgo di stampare A[i][categria]
		syscall						# chiamo print_char(A[i][categoria]
		# stampa separatore
		li $v0, 4					# seleziono print_string
		la $a0, str_separatore				# seleziono stringa str_separatore
		syscall						# chiamo print_string(str_separatore)
		# stampa A[i][colore]
		addi $t3, $t3, 1				# t3 <- &A[i][colore] = &A[i][] + offset(1)
		li $v0, 11					# seleziono print_char
		li $t4, 0					# t4 <- j = 0
		ciclo_stampa_colore:				# for(j=0,j<6,j++)
			slti $t5, $t4, 6				# se(j<6) t5 <- 1 altrimenti t5 <- 0
			beq $t5, $zero, fine_ciclo_stampa_colore	# se(t5==0) ovvero se(j>=6) vai a fine_ciclo...
			add $t5, $t3, $t4				# t5 <- &A[i][j-esimo_char_colore] = &A[i][colore] + j
			lb $a0, 0($t5)					# schelgo di stamare j-esimo char di A[i][colore]
			syscall						# chiamo print_char
			addi $t4, $t4, 1				# j++
			j ciclo_stampa_colore				# prossima iterazione ciclo
		fine_ciclo_stampa_colore:
		# stampa separatore
		li $v0, 4					# seleziono print_string
		la $a0, str_separatore				# seleziono stringa str_separatore
		syscall						# chiamo print_string(str_separatore)
		# stampa A[i][stagione]
		addi $t3, $t3, 6				# t3 <- &A[i][stagione] = &A[i][colore] + offset(6)
		li $v0, 11					# seleziono print_char
		lb $a0, 0($t3)					# scelgo di stampare A[i][stagione]
		syscall						# chiamo print_char(A[i][stagione])
		# stampa separatore
		li $v0, 4					# seleziono print_string
		la $a0, str_separatore				# seleziono stringa str_separatore
		syscall						# chiamo print_string(str_separatore)
		# stampa A[i][descrizione]
		li $v0, 4					# seleziono print_string
		addi $a0, $t3, 1				# a0 <- &A[i][descrizione] = &A[i][stagione] + offset(1)
		syscall						# chiamo print_string(A[i][descrizione])
	addi $t2, $t2, 1				# i++
	j ciclo_stampa
fine_stampa:
	jr $ra
#############################################################################################################
cerca_seq:
##########################################################
# cerca_seq(A[],N,campo,stack[k])
# campo[0,1,2,3]
# output:
#	v0: indirizzo di k trovato oppure 0(zero)
#	v1: indice di k trovato
##########################################################
	lw $t6, 0($sp)					# t6 <- &cerca_k
	addi $sp, $sp, 4
	la $t0, cerca_campo_jat				# t0 <- &cerca_campo_jat[] (jump address table)
	sll $t1, $a2, 2					# t1 <- case * 4
	add $t1, $t0, $t1				# t1 <- &menu_jat[campo] = &menu_jat[] + campo * 4
	lw $t1, 0($t1)					# t1 <- menu_jat[campo]
	jr $t1						# vai a indirizzo in cerca_campo_jat[campo]

	cerca_categoria:
		li $t0, 0						# t0 <- i = 0
		ciclo_cerca_categoria:					# for(i=0, i<N, i++)
			slt $t1, $t0, $a1					# se(i<N) t1 <- 1 altrimenti t1 <- 0
			beq $t1, $zero, cerca_seq_non_trovato			# se(t1==0) ovvero se(i>=N) vai a cerca_seq_non_trovato
			sll $t1, $t0, 2						# t1 <- offset = i * 4
			add $t1, $a0, $t1					# t1 <- &A[i][] = &A[][] + offset(i)
			lw $t2, 0($t1)						# t2 <- A[i][]
			lb $t2, 0($t2)						# t2 <- A[i][categoria]
			lb $t3, 0($t6)						# t3 <- categoria (da cercare)
			beq $t2, $t3, cerca_seq_trovato				# se(A[i][categoria] == categoria) vai a cerca_seq_trovato
			addi $t0, $t0, 1					# i++
			j ciclo_cerca_categoria
	cerca_colore:
		li $t0, 0						# t0 <- i = 0
		ciclo_cerca_colore:					# for(i=0, i<N, i++)
			slt $t1, $t0, $a1					# se(i<N) t1 <- 1 altrimenti t1 <- 0
			beq $t1, $zero, cerca_seq_non_trovato			# se(t1==0) ovvero se(i>=N) vai a cerca_seq_non_trovato
			sll $t1, $t0, 2						# t1 <- offset = i * 4
			add $t1, $a0, $t1					# t1 <- &A[i][] = &A[][] + offset(i)
			lw $t2, 0($t1)						# t2 <- A[i][]
			addi $t2, $t2, 1					# t2 <- &A[i][colore] = &A[i][] + offset(1)
			li $t5, 0						# t5 <- j = 0
			ciclo_cerca_colore_char:				# for(j=0,j<6,j++)
				slti $t7, $t5, 6					# se(j<6) t7 <- 1 altrimenti t7 <- 0
				beq $t7, $zero, cerca_seq_trovato			# se(t7==0) ovvero se(j>=6) vai a cerca_seq_trovato
				add $t7, $t2, $t5					# t7 <- &A[i][j-esimo_char_colore] = &A[i][colore] + j
				lb $t3, 0($t7)						# t3 <- j-esimo char di A[i][colore]
				add $t7, $t6, $t5					# t7 <- &cerca_k[j-esimo_char] = &cerca_k[] + j
				lb $t4, 0($t7)						# t4 <- cerca_k[j-esimo_char]
				bne $t3, $t4, prossimo_ciclo_cerca_colore		# se(A[i][j-esimo_char_colore] != cerca_k[j-esimo_char)
				addi $t5, $t5, 1					# j++
			j ciclo_cerca_colore_char				# prossoma iterazione cerca_colore_char
			prossimo_ciclo_cerca_colore:
				addi $t0, $t0, 1					# i++
				j ciclo_cerca_colore					# prossima iterazione cerca_colore
	cerca_stagione:
		li $t0, 0						# t0 <- i = 0
		ciclo_cerca_stagione:					# for(i=0, i<N, i++)
			slt $t1, $t0, $a1					# se(i<N) t1 <- 1 altrimenti t1 <- 0
			beq $t1, $zero, cerca_seq_non_trovato			# se(t1==0) ovvero se(i>=N) vai a cerca_seq_non_trovato
			sll $t1, $t0, 2						# t1 <- offset = i * 4
			add $t1, $a0, $t1					# t1 <- &A[i][] = &A[][] + offset(i)
			lw $t2, 0($t1)						# t2 <- A[i][]
			addi $t2, $t2, 7					# t2 <- &A[i][stagione] = &A[i] + offset(7)
			lb $t2, 0($t2)						# t2 <- A[i][stagione]
			lb $t5, 0($t6)						# t6 <- cerca_k[]
			beq $t2, $t5, cerca_seq_trovato				# se(A[i][stagione] == k) vai a cerca_seq_trovato
			addi $t0, $t0, 1					# i++
		j ciclo_cerca_stagione
	cerca_descrizione:
		li $t0, 0					# t0 <- i = 0
		ciclo_cerca_descrizione:			# for(i=0, i<N, i++)
			slt $t1, $t0, $a1				# se(i<N) t1 <- 1 altrimenti t1 <- 0
			beq $t1, $zero, cerca_seq_non_trovato		# se(t1==0) ovvero se(i>=N) vai a cerca_seq_non_trovato
			sll $t1, $t0, 2					# t1 <- offset = i * 4
			add $t1, $a0, $t1				# t1 <- &A[i][] = &A[][] + offset(i)
			lw $t2, 0($t1)					# t2 <- A[i][]
			addi $t2, $t2, 8				# t2 <- &A[i][descrizione] = &A[i][] + offset(8)
			li $t5, 0					# t5 <- j = 0
			ciclo_char_descrizione:				# for(j=0, j<16, j++)
				slti $t3, $t5, 16				# se(j < 16) t3 <- 1 altrimenti t3 <- 0
				beq $t3, $zero, cerca_seq_trovato		# se(t3==0), ovvero se(j>=16) vai a cerca_seq_trovato
				sll $t7, $t5, 2					# t7 <- offset(j) = j * 4
				add $t3, $t2, $t7				# t3 <- &A[i][j-esima_word_descrizione]
				lw $t3, 0($t3)					# t3 <- A[i][k-esima_word_descrizione]
				add $t7, $t6, $t7				# t6 <- &cerca_k[j-esima_word]
				lw $t4, 0($t7)					# t4 <- cerca_k[j-esima_word]
				bne $t3, $t4, prossimo_ciclo_cerca_descrizione	# se(A[i][j-esima_word_descrizione] != cerca_k[j-esima_word]) vai a prossimo_ciclo_cerca_descrizione
				addi $t5, $t5, 1				# j++
			j ciclo_char_descrizione			# torna a ciclo_char_descrizione per prossima iterazione
			j cerca_seq_trovato				# se(A[i][descrizione] == k) vai a cerca_seq_trovato
			prossimo_ciclo_cerca_descrizione:
				addi $t0, $t0, 1				# i++
				j ciclo_cerca_descrizione
	cerca_seq_non_trovato:
		li $v0, 0			# return 0(errore) e continua con cerca_seq_return
		j cerca_seq_return		# vai a cerca_seq_return
	cerca_seq_trovato:
		move $v0, $t1			# return indirizzo di A[i][] in cui c'è l'elemento cercato
		move $v1, $t0			# return_i indice di A[i][] in cui c'è l'elemento cercato
	cerca_seq_return:
		jr $ra
################################################################################################################################
filtra:
#####################################
# input: A[],N,campo,i,&cerca_k
# output: B[],M
####################################
lw $t0, 0($sp)				# t0 <- &cerca_k
addi $sp, $sp, -24			# sp <- sp +4 -28
sw $ra, 24($sp)
sw $s5, 20($sp)
sw $s4, 16($sp)
sw $s3, 12($sp)
sw $s2, 8($sp)
sw $s1, 4($sp)
sw $s0, 0($sp)
move $s5, $t0				# s5 <- &cerca_k

lb $t0, 0($s5)				# t0 <- 1° char di cerca_k
beq $t0, $zero, filtra_return_a		# se(cerca_k == 0) vai a return_a, cioè restituisci A senza filtrare

move $s1, $a0				# s1 <- &A[][]
move $s2, $a1				# s2 <- N
move $s3, $a2				# s3 <- campo
move $s4, $a3				# s4 <- i
la $s0, B				# s0 <- &B[][]
# a0 == A[]
# a1 == N
# a2 == campo
addi $sp, $sp, -4
sw $s5, 0($sp)				# &cerca_k in stack
jal cerca_seq				# chiamo cerca_seq(A[],N,campo,stack[k]) che restituisce in v0 l'indirizzo di k_trovato
beq $v0, $zero, fine_filtra		# se (&k_trovato == errore(0)) vai a fine_filtra
sll $t0, $s4, 2				# t0 <- offset(i) = i * 4
add $t0, $s0, $t0			# t0 <- &B[i][] = &B[][] + offset(i)
lw $t0, 0($t0)				# t0 <- B[i][]
lw $t4, 0($v0)				# t4 <- A[k] = &A[k][]
li $t2, 0				# t2 <- j=0
ciclo_filtra_copia:			# for(j=0, j<18, j++)
	slti $t3, $t2, 18			# se(j < 18) t3 <- 1 altrimenti t3 <- 0
	beq $t3, $zero, fine_ciclo_filtra_copia	# se(t3==0), ovvero se(j>=18) vai a fine_ciclo_filtra_copia
	sll $t3, $t2, 2				# t3 <- offset(j) = j * 4
	add $t1, $t4, $t3			# t1 <- &A[k][j-esima_word]
	lw $t1, 0($t1)				# t1 <- A[k][j-esima_word]
	add $t3, $t0, $t3			# t3 <- &B[i][j-esima_word]
	sw $t1, 0($t3)				# B[i][j-esima_word] <- A[k][j-esima_word]
	addi $t2, $t2, 1			# j++
j ciclo_filtra_copia			# loop
fine_ciclo_filtra_copia:
addi $s1, $v0, 4		# &A[][] = &k + 4
addi $t0, $v1, 1		# t0 <- indice di k_trovato + 1
sub $s2, $s2, $t0		# N = N - (indice di k_trovato + 1 )
addi $s4, $s4, 1		# i++
move $a0, $s1			# a0 <- &A[][]
move $a1, $s2			# a1 <- N
move $a2, $s3			# a2 <- campo
move $a3, $s4			# a3 <- i
addi $sp, $sp, -4
sw $s5, 0($sp)			# &cerca_k in stack
jal filtra			# chiamata ricorsiva a filtra()
j return			# vai a return
fine_filtra:
	move $v0, $s0			# return_v0 <- indirizzo di B[][]
	move $v1, $s4			# return_v1 <- numero di elementi di B[][]
return:
	# return_v0 <- indirizzo di B[][]
	# return_v1 <- numero di elementi di B[][]
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	lw $s3, 12($sp)
	lw $s4, 16($sp)
	lw $s5, 20($sp)
	lw $ra, 24($sp)
	addi $sp $sp, 28
	
	jr $ra
filtra_return_a:
	move $v0, $a0			# return v0 <- A[]
	move $v1, $a1			# return v1 <- N
	j return			# vai a return
#########################################################################################
elimina:
# a0 = A[]
# a1 = N
# v0 = N-1
	move $t7, $a0				# t7 <- &A[]
	li $v0, 4				# seleziono print_string
	la $a0, str_elimina_id			# scelgo di stampare str_elimina_id
	syscall					# chiamo print_string(str_elimina_id)
	li $v0, 5				# selezione read_int
	syscall					# v0 <- read_int()
	slt $t0, $v0, $zero			# se(id<0) t0 <- 1 altrimenti t0 <- 0
	bne $t0, $zero, elimina_id_errore	# se(t0!=0) ovvero se(id<0) vai a elimina_id_errore
	slt $t0, $v0, $a1			# se(id<N) t0 <- 1 altrimenti t0 <- 0
	beq $t0, $zero, elimina_id_errore	# se(t0==0) ovvero se(id>=N) vai a elimina_id_errore
	addi $t6, $v0, 1			# id = id + 1
	ciclo_elimina:				# for(id,id<N,id++) id è l'elemento successivo all'eliminato
		slt $t0, $t6, $a1			# se(id<N) t0 <- 1 altrimenti t0 <- 0
		beq $t0, $zero, fine_ciclo_elimina	# se(t0==0) ovvero se(id>=N) vai a fine_ciclo_elimina
		sll $t0, $t6, 2				# t0 <- offset(id+1) = id+1 * 4
		add $t0, $t7, $t0			# t0 <- &A[id+1] = &A[] + offset(id+1)
		lw $t1, 0($t0)				# t1 <- &A[id+1][]
		addi $t0, $t0, -4			# t0 <- &A[id+1] - 4 == &A[id]
		lw $t0, 0($t0) 				# t0 <- &A[id][]
		li $t2, 0				# t2 <- i = 0
		ciclo_elimina_sposta:			# for(i=0,i<18,i++) 18 è il numero di word da spostare
			slti $t3, $t2, 18			# se(i<18) t3 <- 1 altrimenti t3 <- 0
			beq $t3, $zero, fine_ciclo_elimina_sposta	# se(t3==0) ovvero se(i>=18) vai a fine_ciclo...
			sll $t3, $t2, 2				# t3 <- offset(i) = i * 4
			add $t4, $t1, $t3			# t4 <- &A[id+1][i-esima word]
			lw $t4, 0($t4)				# t4 <- A[id+1][i-esima word]
			add $t5, $t0, $t3			# t5 <- &A[id][i-esima word]
			sw $t4, 0($t5)				# A[id][i-esima word] <- A[id+1][i-esima word]
			addi $t2, $t2, 1			# i++
		j ciclo_elimina_sposta			# prossima iterazione ciclo_elimina_sposta
		fine_ciclo_elimina_sposta:
		addi $t6, $t6, 1			# id++
	j ciclo_elimina				# prossima iterazione ciclo_elimina
	fine_ciclo_elimina:			
	addi $v0, $a1, -1			# return(N-1)
	jr $ra					# torna a procedura chiamante
	elimina_id_errore:
		li $v0, 4				# seleziono print_string()
		la $a0, str_elimina_id_errore		# scelgo di stampare str_elimina_id_errore
		syscall					# chiamo print_string(str...)
		jr $ra					# torna al menu
fine_elimina:
######################################################################
casuale:
# tipo[scarpe,pantaloni,maglia,cappello]
# campo[colore,stagione]
	
# campo_0{
#	input k(campo_0)
# }
# campo_1{
#	input k(campo_1)
# }	
# for each TIPO{
#	B[] <- filtra(A[],N,campo_0,k)
#	B[] <- filtra(B[],M,campo_1,k)
#	B[] <- filtra(B[],M,CAMPO[TIPO],tipo)
#		se(M!=0) {
#			seed <- random(seed,M)
#			print(B[seed][])
#			se(combinazioni==0) { combinazioni <- M }
#			altrimenti { combinazioni <- combinazioni * M }
#		}
# }
# stampa(combinazioni)
# next <- input()
# se(next==s)
# 	casusale(A[],N)
# altrimenti
# 	return()

# a0 == A[]
# a1 == N

# push #
addi $sp, $sp, -32
sw $s0, 28($sp)
sw $s1, 24($sp)
sw $s2, 20($sp)
sw $s3, 16($sp)
sw $s4, 12($sp)
sw $s5, 8($sp)
sw $s6, 4($sp)
sw $ra, 0($sp)
# fine push #
move $s0, $a0					# s0 <- A[]
move $s1, $a1					# s1 <- N
la $s6, cerca_k					# s6 <- &cerca_k
	casuale_input_colore:
		jal pulisci_cerca_k				# chiamo pulisci_cerca_k()
		li $v0, 4					# selezione print_string
		la $a0, str_casuale_inserisci_colore		# scelgo di stampare str_casuale_inserisci_colore
		syscall						# chiamo print_string(str...)
		li $v0, 8					# seleziono read_string
		la $a0, buffer_str				# seleziono buffer_str
		li $a1, 8					# leggo 8 charatteri (ne voglio 6, il 7° è RETURN, l'8° è FINE_STRINGA)
		syscall						# a0 <- colore = read_string()
		la $t3, cerca_k					# t3 <- &cerca_k
		li $t2, 0					# t2 <- j = 0
		ciclo_casuale_colore_char:			# for(j=0,j<6,j++) trasferisco 6 char in stack
			slti $t0, $s5, 6				# se(j<6) t0 <- 1 altrimenti t0 <- 0
			beq $t0, $zero, fine_casuale_input_colore	# se(t0==0) ovvero se(j>=6) vai a fine_ciclo...
			add $t1, $a0, $t2				# t1 <- &buffer_str + j
			add $t0, $t3, $t2				# t0 <- &cerca_k + j
			lb $t1, 0($t1)					# t1 <- buffer_str(j-esimo char)
			beq $t1, 0xa, casuale_colore_return		# se il char letto equivale a 0x0a(return) vai a casuale_colore_return
			sb $t1, 0($t0)					# cerca_k[j-esimo char] <- buffer_str[j-esimo char]
			addi $t2, $t2, 1				# j++
		j ciclo_casuale_colore_char			# prossima iterazione
		casuale_colore_return:
			sb $zero, 0($t0)				# cerca_k[j-esimo char] <- 0x00
	fine_casuale_input_colore:
	casuale_input_stagione:
		li $v0, 4					# selezione print_string
		la $a0, str_casuale_inserisci_stagione		# scelgo di stampare str_casuale_inserisci_stagione
		syscall						# chiamo print_string(str...)
		li $v0, 12					# seleziono read_char
		syscall						# v0 <- stagione = read_char()
		la $t0, cerca_k_stagione			# t0 <- &cerca_k_stagione
		beq $v0, 0x0a, casuale_stagione_return		# se(stagione==return) vai casuale_stagione_return
		sb $v0, 0($t0)					# cerca_k_stagione <- stagione = read_char()
		j fine_casuale_input_stagione			# vai a fine_casuale_input_stagione
		casuale_stagione_return:
			sb $zero, 0($t0)				# cerca_k_stagione <- 0x00
	fine_casuale_input_stagione:
li $s5, 0					# s5 <- combinazioni = 0
li $s2, 0					# s2 <- i = 0
ciclo_casuale_filtra:				# for each CATEGORIA (come se CATEGORIA fosse un tipo enumerativo e i fosse il suo indice)
	slti $t0, $s2, 4				# se(i<4) t0 <- 1 altrimenti t0 <- 0
	beq $t0, $zero, fine_ciclo_casuale_filtra	# se(t0==0) ovvero se(i>=4) vai a fine_ciclo...
	move $a0, $s0					# a0 <- A[]
	move $a1, $s1					# a1 <- N
	li $a2, 1					# a2 <- CAMPO[COLORE]
	li $a3, 0					# a3 <- i di filtra = 0
	la $t0, cerca_k					# t0 <- &cerca_k
	addi $sp, $sp, -4				# spazio per 1 word in stack
	sw $t0, 0($sp)					# push &cerca_k in stack
	jal filtra					# chiamo filtra(A[],N,COLORE,0,cerca_k)
	move $a0, $v0					# a0 <- B[]
	move $a1, $v1					# a1 <- M
	li $a2, 2					# a2 <- CAMPO[STAGIONE]
	li $a3, 0					# a3 <- i di filtra = 0
	la $t0, cerca_k_stagione			# t0 <- &cerca_k_stagione
	addi $sp, $sp, -4				# spazio per 1 word in stack
	sw $t0, 0($sp)					# push &cerca_k_stagione in stack
	jal filtra					# chiamo filtra(B[],M,STAGIONE,0,cerca_k_stagione)	
	switch_casuale_categoria:			# switch(i)
		beq $s2, $zero, casuale_categoria_s		# se(i==0) vai a casuale_categoria_s
		beq $s2, 1, casuale_categoria_p			# se(i==1) vai a casuale_categoria_p
		beq $s2, 2, casuale_categoria_m			# se(i==2) vai a casuale_categoria_m
		beq $s2, 3, casuale_categoria_c			# se(i==3) vai a casuale_categoria_c
		casuale_categoria_s:				# case 0
			li $t0, 0x73					# t0 <- categoria = "s"
			j fine_switch_casuale_categoria			# break
		casuale_categoria_p:				# case 1
			li $t0, 0x70					# t0 <- categoria = "p"
			j fine_switch_casuale_categoria			# break
		casuale_categoria_m:				# case 2
			li $t0, 0x6d					# t0 <- categoria = "m"
			j fine_switch_casuale_categoria			# break
		casuale_categoria_c:				# case 3
			li $t0, 0x63					# t0 <- categoria = "c"
	fine_switch_casuale_categoria:
	move $a0, $v0					# a0 <- B[]
	move $a1, $v1					# a1 <- M
	li $a2, 0					# a2 <- CAMPO[CATEGORIA]
	li $a3, 0					# a3 <- i di filtra  = 0
	la $t1, cerca_k_categoria			# t1 <- &cerca_k_categoria
	sb $t0, 0($t1)					# cerca_k_categoria <- categoria
	addi $sp, $sp, -4				# faccio spazio per 1 word in stack
	sw $t1, 0($sp)					# stack <- &cerca_k_categoria che contiene categoria da cercare
	jal filtra					# chiamo filtra(B[],M,CATEGORIA,0,cerca_k_categoria)
	beq $v1, $zero, casuale_m_0			# se(M==0) vai a casuale_m_0 cioè salta calcolo combinazioni e stampa
	beq $s5, $zero, casuale_combinazioni_0		# se(combinazioni==0) vai a casuale_combinazioni_0
		mul $s5, $s5, $v1				# combinazioni <- combinazioni * M
		j casuale_stampa				# vai a casuale_stampa
	casuale_combinazioni_0:
		move $s5, $v1					# combinazioni <- M
	casuale_stampa:
		la $t0, seed					# t0 <- &seed
		lw $a0, 0($t0)					# a0 <- seed
		move $a1, $v1					# a1 <- M == range di random
		jal random					# (v0 <- nuovo_seed, v1 <- numero_random) = random(seed,M)
		la $t0, seed					# t0 <- &seed
		sw $v0, 0($t0)					# seed <- nuvo_seed
		la $t1, B					# t1 <- &B[]
		sll $t0, $v1, 2					# t0 <- offset(n_random) = n_random * 4
		add $a0, $t1, $t0				# a0 <- &B[n_random] = &B[] + offset(n_random)	
		li $a1, 1					# a1 <- 1 (voglio stampare solo B[n_random])
		jal stampa					# chiamo stampa(B[n_random ,1)
	casuale_m_0:						# salta stampa() e calcolo combinazioni
	addi $s2, $s2, 1				# i++
j ciclo_casuale_filtra				# prossima iterazione
fine_ciclo_casuale_filtra:
li $v0, 4					# seleziono print_string
la $a0, str_casuale_combinazioni		# schelgo di stampare str_casuale_combinazioni
syscall						# chiamo print_string(str_casuale_combinazioni)
li $v0, 1					# seleziono print_int
move $a0, $s5					# scelgo di stampare combinazioni
syscall						# chiamo print_int(combinazioni)
li $v0, 4					# seleziono print_string
la $a0, str_casuale_next			# schelgo di stampare str_casuale_next
syscall 					# chiamo print_string(str_casuale_next)
li $v0, 12					# seleziono read_char
syscall						# v0 <- next = char()
beq $v0, 0x73, fine_casuale_input_stagione	# se(next==s) torna a prima di ciclo_casuale_filtra
fine_casuale:
# pop #
lw $ra, 0($sp)
lw $s6, 4($sp)
lw $s5, 8($sp)
lw $s4, 12($sp)
lw $s3, 16($sp)
lw $s2, 20($sp)
lw $s1, 24($sp)
lw $s0, 28($sp)
addi $sp, $sp, 32
# fine pop #
jr $ra
####################################################
random:
# a0 = seed
# a1 = range (da 0 a range-1)
# v0 = nuovo_seed
# v1 = random_number_in_range
	
li $t0, 7		# t0 <- k = 7
li $t1, 32		# t1 <- numero di bit del seed = 32
	
srl $t2, $a0, $t0	# t2 <- s+ = shift_dx s di k posizioni
xor $t2, $t2, $a0	# t2 <- s* = s+ xor s
sub $t3, $t1, $t0	# t3 <- n - k
sll $t3, $t2, $t3	# t3 <- s- = shift_sx s* di (n-k) posizioni
xor $t2, $t3, $t2	# t2 <- s = s- xor s*

move $v0, $t2		# v0 <- nuovo_seed

divu $t2, $a1		# hi <- nuvo_seed % range
mfhi $v1		# v1 <- random_number_in_range

jr $ra
########################################################################
