.data
inizio: .asciiz "Benvenuto in '15'!!!\nScopo del gioco e' ordinare i tasselli facendone scorrere uno alla volta nello spazio vuoto fino ad ottenere il seguente schema:\n"
istruzioni: .asciiz "\nPer muovere un tassello nello spazio vuoto utilizza i seguenti comandi:\n4: verso sinistra\n6: verso destra\n8: verso l'alto\n2: verso il basso.\n"
partita1: .asciiz "Inserire il nome del giocatore(max 7 caratteri):\n"
partita2: .asciiz "\nInserire data (GG-MM-AA):\n"
menu: .asciiz "\nMenu':\n1-Nuova partita\n2-Stampa classifica\n3-Termina gioco\n-->"
nonvalido: .asciiz "Opzione inserita non valida.\n\n"
difficolta: .asciiz "\nDifficolta' partita: "
punteggio: .asciiz "\nPunteggio: "
mossa: .asciiz "\nInserisci mossa (2, 4, 6, 8) o termina partita (0)-mosse non valide non effettuano operazioni- : "
acapo: .asciiz "\n"
spazio: .asciiz " "
finepartita: .asciiz "\nFine della partita."
partitavinta: .asciiz "\n\nCONGRATULAZIONI! Partita vinta!"
tab: .asciiz "\t"
name: .asciiz "\tNOME"
point: .asciiz "\tPUNTEGGIO"
date: .asciiz "\tDATA"
jat: .word default, nuovapartita, classifica, exit
.align 2
nome: .space 8
data: .space 12
matrix: .space 64
#lista: .space 120					#classifica dei 5 migliori giocatori
lista: .byte 45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0
.text
main:
	li $v0, 4						#stampa istruzioni iniziali
	la $a0, inizio
	syscall
	la $a0, matrix
	jal init						#inizializzazione matrice
									#input: $a0 = base address matrix
	la $a0, matrix
	jal printschema					#stampa matrice
									#input: $a0 = base address matrix
	la $a0, istruzioni
	li $v0, 4
	syscall							#stampa istruzioni per l'interazione col gioco
	
	li $s0, 0						#$s0 = costante utilizzata per la generazione di numeri casuali
	li $s2, 0						#$s2 = numero di giocatori in classifica
	
stampamenu:							#MENU e INIZIALIZZAZIONE VALORI STANDARD
									
	li $s1, 15						#$s1 = posizione attuale della cella vuota
	li $s3, 1001					#$s3 = punteggio di partenza di ogni partita
	
	li $v0, 4						#stampa matrice
	la $a0, menu
	syscall
	
	li $v0, 5						#SCELTA DELL'OPERAZIONE
	syscall							
	move $t0, $v0					#$t0 = numero k della scelta
	
	slt $t1, $zero, $t0				#controllo: se k <= 0 o k >= 4 va al caso default(operazione non valida)
	beq $t1, $zero, default
	slti $t1, $t0, 4
	beq $t1, $zero, default
									#SCELTA PER MEZZO DELLA JUMP ADDRESS TABLE
	sll $t1, $t0, 2
	la $t0, jat
	add $t1, $t1, $t0
	lw $t1, 0($t1)
	jr $t1
	
nuovapartita:						#NUOVA PARTITA
	li $v0, 4
	la $a0, partita1
	syscall
	
	li $v0, 8						#inserimento nome
	la $a0, nome
	li $a1, 8
	syscall
	li $v0, 4
	la $a0, partita2
	syscall
	li $v0, 8						#inserimento data
	la $a0, data
	li $a1, 12
	syscall
	li $v0, 4
	la $a0, acapo
	syscall
	
	la $a0, nome					#calcola la lunghezza del nome
	jal slength						#input:		$a0 = base address stringa
									#output:	$v0 = lunghezza stringa
	
	move $a1, $v0					#la lunghezza del nome del giocatore e' fornita come argomento della procedura che genera il numero casuale
	la $t0, nome
	lb $t1, 0($t0)					#carica primo byte del nome
	lb $a0, 4($t0)					#carica quarto byte del nome
	add $a0, $a0, $t1
	add $a0, $a0, $s0
	jal random						#il seed e' la somma di due byte del nome sommata alla costante $s0 per aumentare la casualità 
									#in partite successive giocate dallo stesso giocatore
									#input:	 $a0 = seed
									#	 	 $a1 = numero di xorshift
									#output: $v0 = numero random
									
	move $s0, $v0					#$s0 = numero random
		
	li $t0, 20
	div $s0, $t0
	mfhi $s0						#$s0 = numero random modulo 20(cosicche' non si possano fare piu di 20 mosse)
	slti $t0, $s0, 10
	beq $zero, $t0, maggdieci		#controllo: se il numero di mosse e' inferiore a 10 viene incrementato a 10(
									#affinche il numero minimo di mosse sia 10)
									
	addi $s0, $s0, 10				#$s0 = numero pseudo-casuale di mosse che stabiliscono la difficolta' della partita
	
maggdieci:	
	li $v0, 4						#difficolta' fornita all'utente
	la $a0, difficolta
	syscall
	li $v0, 1
	move $a0, $s0
	syscall
	li $v0, 4
	la $a0, acapo
	syscall
	syscall
	
	la $t0, data
	lb $t1, 0($t0)
	lb $t2, 1($t0)
	add $t1, $t1, $t2
	lb $t2, 3($t0)
	add $t1, $t1, $t2
	lb $t2, 4($t0)
	add $t1, $t1, $t2
	lb $t2, 6($t0)
	add $t1, $t1, $t2
	lb $t2, 7($t0)
	add $a0, $t1, $t2				#viene generato un nuovo numero random: il seed e' la somma dei numeri della data
	move $a1, $s0					#il numero di xorshift e' il numero di mosse della partita
	jal random						#input:	 $a0 = seed
									#	 	 $a1 = numero di xorshift
									#output: $v0 = numero random
									
	move $a2, $v0					#il numero random generato e' fornito come argomento alla procedura che esegue le mosse casuali
	la $a0, matrix
	move $a1, $s0
	jal createschema				#creazione dello schema iniziale in base al numero di mosse e alla data fornita dall'utente
									#input:		$a0 = base address matrix
									#			$a1 = numero di mosse
									#			$a2 = numero random per la prima mossa casuale
									#output:	$v0 = posizione dello spazio
									
	move $s1, $v0					#$s1 = posizione attuale dello spazio
	
nuovamossa:
	addi $s3, $s3, -1				#ogni volta che viene effettuata una nuova mossa (lecita o meno) il punteggio e' decrementato di 1 punto
	la $a0, matrix
	jal printschema					#visualizzazione dello schema da risolvere
	li $v0, 4
	la $a0, punteggio				#visualizzazione del punteggio corrente
	syscall
	li $v0, 1
	move $a0, $s3
	syscall
	
	li $v0, 4						#inserimento mossa
	la $a0, mossa
	syscall
	li $v0, 5						
	syscall
	beq $zero, $v0, termina			#con la mossa 0 la partita e' terminata
	move $a1, $v0					#$a1 = numero mossa
	la $a0, matrix
	move $a2, $s1
	jal muovi						#input:	$a0 = base address matrix
									#		$a1 = indice mossa
									#		$a2 = posizione della cella vuota
									#output:$v0 = nuova posizione della cella vuota
									
	move $s1, $v0					#$s1 = posizione della cella vuota
	la $a0, matrix
	jal check						#ad ogni mossa si controlla che lo schema non sia completato e quindi la partita terminata
									#input: $a0 = base address matrix
									
	bne $zero, $v0, vinto			#se $v0 = 1 (cioe' $v0 != 0) la partita e' vinta
	j nuovamossa					#altrimenti si richiede l'inserimento di una nuova mossa

termina:
	li $v0, 4
	la $a0, finepartita				#messaggio di fine partita
	syscall
	addi $s3, $s3, -500				#se una partita e' terminata per rinuncia del giocatore il punteggio viene decrementato di 500 punti
	j punt
vinto:
	li $v0, 4
	la $a0, partitavinta			#messaggio di vittoria
	syscall
	addi $s3, $s3, 1000				#se una partita e' terminata per vittoria del giocatore il punteggio viene incrementato di 1000 punti
punt:
	li $v0, 4
	la $a0, punteggio				#visualizzazione del punteggio finale
	syscall
	move $a0, $s3
	li $v0, 1
	syscall
	li $v0, 4
	la $a0, acapo
	syscall
	syscall
	
	#SALVATAGGIO IN CLASSIFICA
	addi $s2, $s2, 1				#viene incrementato il numero di giocatori in classifica
	slti $t0, $s2, 6				
	bne $zero, $t0, inserimento		#se c'e' posto in classifica ($s2<6) si passa direttamente all'inserimento nell'ultima riga libera
									#altrimenti si controlla se il punteggio e' inferiore all'ultimo punteggio in classifica
	li $s2, 5						#se $s2>5 il numero di giocatori in classifica rimane 5
	la $t0, lista
	lw $t1, 128($t0)				#$t1 = punteggio minore in classifica
	slt $t0, $s3, $t1				#$t0 = 1 if $s3 < punteggio minore (quindi il nome non entra in classifica)
	bne $zero, $t0, nonins
	
inserimento:
	li $t0, 24
	mul $t0, $t0, $s2
	addi $t0, $t0, -24				#il conteggio dei giocatori parte da 1, mentre i rispettivi posti in classifica da 0
									#pertanto bisogna considerare una riga di memoria in meno
	la $t1, lista
	add $t1, $t1, $t0				#$t1 = base address dell'ultima riga in classifica da riempire
	move $t3, $t1					#$t3 = copia del base address dell'ultima riga in classifica da riempire
	
	#TRASCRIZIONE NOME IN CLASSIFICA
	la $t0, nome
	li $t4, 10
	li $t5, 0
controllonome:						#eliminazione del carattere di invio a capo per facilitare la stampa della classifica
	lb $t2, 0($t0)					#$t2 = carattere esaminato
	beq $t4, $t2, finenome
	beq $zero, $t2, finenome
	sb $t2, 0($t1)
	addi $t0, $t0, 1
	addi $t1, $t1, 1
	j controllonome
finenome:
	sb $zero, 0($t1)
	
	#TRASCRIZIONE PUNTEGGIO IN CLASSIFICA
	sw $s3, 8($t3)
	
	#TRASCRIZIONE DATA IN CLASSIFICA
	la $t0, data
	lw $t2, 0($t0)
	sw $t2, 12($t3)
	lw $t2, 4($t0)
	sw $t2, 16($t3)
	sw $zero, 20($t3)				#il terzo byte della data e' azzerato(viene ignorato il carattere finale "\n" = 10)
	
	la $a0, lista
	li $a1, 0
	addi $a2, $s2, -1
	jal ordinalista					#input:	$a0 = base address lista
									#		$a1 = indice i della riga del primo punteggio da ordinare in classifica
									#		$a2 = indice j della riga dell'ultimo punteggio da ordinare in classifica
	
nonins:	
	la $a0, matrix					#reinizializzazione matrice
	jal init
	j stampamenu					#ritorno al menu' principale
	
classifica:							#VISUALIZZAZIONE CLASSIFICA	
	la $a0, lista
	jal printlista
	j stampamenu					#ritorno al menu' principale
	
default:
	li $v0, 4
	la $a0, nonvalido				#se l'operazione scelta non e' nel menu' viene segnalato e riproposto il menu'
	syscall
	j stampamenu

exit:								#EXIT
	li $v0, 10
	syscall

###########################################################
#------------------------PROCEDURE------------------------#
#procedura che calcola la lunghezza del nome del giocatore (la quale viene poi utilizzata per la generazione di un numero casuale di mosse)
slength:							#$a0 = base address stringa
									#$v0 = lunghezza stringa
	addi $sp, $sp, -4
	sw $s0, 0($sp)
	
	move $s0, $a0
	li $t0, 0						#$t0 = contatore caratteri
	li $t1, 10						#$t1 = 10 = "\n"
loopslength:
	lb $t2, 0($s0)
	beq $zero, $t2, fineslength		#se il carattere caricato in $t2 e' il terminatore di stringa ("0") o il carattere "\n" si termina il conteggio
	beq $t1, $t2, fineslength
	addi $t0, $t0, 1				#se il nome non e' terminato si incrementa il contatore di caratteri
	addi $s0, $s0, 1				#si incrementa di 1 byte l'indirizzo del carattere da esaminare
	j loopslength
fineslength:
	move $v0, $t0
	
	lw $s0, 0($sp)
	addi $sp, $sp, 4
	jr $ra
	
######################################
#procedura che fornisce un numero random in base ad un seed e ad un numero di xorshift da effettuare
random:								#$a0 = seed
									#$a1 = numero di xorshift
									#$v0 = numero random
	addi $sp, $sp, -8
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	
	move $s0, $a0
	move $s1, $a1
	li $t0, 0						#$t0 = contatore xorshift
	
looprandom:
	sll $t1, $s0, 1					#il seed e' shiftato a sinistra di una posizione
	xor $s0, $s0, $t1				#nuovo numero e' dato dallo xor del seed con se stesso shiftato
	addi $t0, $t0, 1
	bne $t0, $s1, looprandom		#se sono stati effettuati il numero stabilito di xorshift si termina, altrimenti si ripete

	move $v0, $s0
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	addi $sp, $sp, 8
	jr $ra
	
######################################
#procedura che stampa la matrice 4x4
printschema:						#$a0 = base address

	addi $sp, $sp, -8 
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	
	move $s0, $a0
	
	li $t0, 16						#$t0 = numero tot celle
	li $t1, 0						#$t1 = numero celle stampate
nextcella:
	lw $s1, 0($s0)					#$s1 = prossimo numero  n da stampare
	slti $t2, $s1, 10				
	beq $zero, $t2, duecifre		#se n >= 10 non e' necessario stampare uno spazio prima del numero per allinearlo alla tabella
									#quindi non si stampa lo spazio precedente al numero
	li $v0, 4
	la $a0, spazio
	syscall
duecifre:
	beq $zero, $s1, printvuoto		#se il numero da stampare e' 0 si stampa uno spazio che rappresenta la cella vuota
									#altrimenti si stampa il numero e poi uno spazio
	li $v0, 1
	move $a0, $s1
	syscall
	j nonvuoto
printvuoto:
	li $v0, 4
	la $a0, spazio
	syscall
nonvuoto:
	li $v0, 4
	la $a0, spazio
	syscall
	
	addi $t1, $t1, 1				#incremento del numero di celle stampate
	addi $s0, $s0, 4				#incremento dell'indirizzo della prossima cella da stampare
	li $t2, 4
	div $t1, $t2
	mfhi $t2
	bne $zero, $t2, noendriga		#se sono state stampate un numero di celle multiplo di 4 la riga e' finita e si va a capo
	li $v0, 4
	la $a0, acapo
	syscall
noendriga:
	beq $t0, $t1, fineprint			#se sono stampate 16 celle la matrice e' stata stampata tutta
	j nextcella
	
fineprint:
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	addi $sp, $sp, 8
	jr $ra
	
######################################
#procedura che inizializza la matrice come se lo schema fosse risolto correttamente
init:								#$a0 = base address matrix
	addi $sp, $sp, -8 
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	
	move $s0, $a0
	li $t0, 1						#$t0 = prossimo numero da inserire nella matrice
	li $t1, 16						#$t1 = numero di celle della matrice
next:
	beq $t1, $t0, fineinit			#il numero 16 non viene inserito nella matrice: al posto 16 viene inserito li spazio vuoto
	sw $t0, 0($s0)					#il numero in $t0 viene memorizzato nella matrice
	addi $t0, $t0, 1				#incremento del numero e dell'indirizzo della cella da riempire
	addi $s0, $s0, 4
	j next							#ciclo ripetuto fino all'inserimento di 15 numeri

fineinit:
	sw $zero, 0($s0)				#memorizzazione dello spazio vuoto
	
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	addi $sp, $sp, 8
	jr $ra
	
######################################
#procedura che crea lo schema iniziale di gioco spostando la cella vuota secondo mosse casuali
createschema:						#$a0 = base address matrix
									#$a1 = numero di mosse
									#$a2 = numero random per la prima mossa casuale
									#$v0 = posizione dello spazio

	addi $sp, $sp, -20
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)
	sw $ra, 12($sp)
	sw $s3, 16($sp)
	
	move $s0, $a0
	move $s1, $a1					#$s1 = numero di mosse da effettuare
	move $s2, $a2					#$s2 = numero random per la generazione di mosse casuali
	li $s3, 15						#$s3 = posizione dello spazio
	
rieseguimossa:
	move $a0, $s2
	move $a1, $s3
	move $a2, $s0
	jal eseguimossa					#esegue una mossa casuale, data la posizione dello spazio vuoto e il numero random
									#input:	$a0 = numero random
									#		$a1 = posizione dello spazio
									#		$a2 = base address matrix
									#output:$v0 = nuova posizione dello spazio
									
	move $s3, $v0					#si aggiorna il valore la posizione della cella vuota con quella nuova fornita dalla procedura
	addi $s1, $s1, -1				#viene decrementato il numero di mosse da effettuare
	sll $t0, $s2, 1					
	xor $s2, $t0, $s2				#xorshift del numero random per ottenerne un altro
	bne $zero, $s1, rieseguimossa	#se il numero di mosse da effettuare non e' 0 si riesegue la procedura eseguimossa
	
	move $v0, $s3					#la nuova posizione e' restituita dalla procedura
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	lw $ra, 12($sp)
	lw $s3, 16($sp)
	addi $sp, $sp, 20
	jr $ra
######################################
#procedura che esegue uno spostamento della cella vuota in base
#ad un numero random fornito e all'attuale posizione della cella stessa	
eseguimossa:						#$a0 = numero random
									#$a1 = posizione dello spazio
									#$a2 = base address matrix
									#$v0 = nuova posizione dello spazio
									
	#gli indici di posizione sono da intendersi nel seguente modo:
	#   ---------------------------------
	#	|	0	|	1	|	2	|	3	|
	#   ---------------------------------
	#	|	4	|	5	|	6	|	7	|
	#   ---------------------------------
	# 	|	8	|	9	|	10	|	11	|
	#   ---------------------------------
	# 	|	12	|	13	|	14	|	15	|
	
	
	addi $sp, $sp, -24
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)
	sw $s3, 12($sp)
	sw $s4, 16($sp)
	sw $ra, 20($sp)
	
	move $s0, $a0					#$s0 = numero pseudo-casuale
	move $s1, $a1					#$s1 = posizione cella vuota
	move $s2, $a2					#$s2 = base address matrix
	
	li $t0, 0						#flag della mossa a destra
	li $t1, 0						#flag della mossa a sinistra
	li $t2, 0						#flag della mossa in basso
	li $t3, 0						#flag della mossa in alto
	
	li $t4, 4
	div $s1, $t4
	mfhi $t4						#$t4 = pos%4
	slti $t0, $t4, 3				#se (pos%4)<3 abilita mossa a destra
	slt $t1, $zero, $t4				#se 0<(pos%4) abilita mossa a sinistra
	slti $t2, $s1, 12				#se pos<12 abilita mossa a in basso
	li $t4, 3
	slt $t3, $t4, $s1				#se 3<pos abilita mossa a in alto
		
	add $s3, $t0, $t1
	add $s3, $s3, $t2
	add $s3, $s3, $t3				#$s3 = mosse_disp = $t0 + $t1 + $t2 + $t3 = numero di mosse disponibili
	
	div $s0, $s3
	mfhi $s4						#$s4 = numero random modulo numero di mosse disponibili (random%mosse_disp) = indice (pseudo-casuale) m della mossa da effettuare
		
	#i successivi controlli e spostamenti della cella vuota sono eseguiti a partire dalla seguente tabella:
	#(in base al numero di mosse disponibili e all'indice m -casuale- della mossa si stabilisce la mossa la effettuare)
	
	#  mosse_disp		|dx	|sx	| down	|up	|
	# 		4			| 0 | 1	|  2	| 3	|
	#----------------------------------------
	# 		3			| 0 | 1	|  2	| x	|
	# 		3			| 0 | 1	|  x	| 2	|
	# 		3			| 0 | x	|  1	| 2	|
	# 		3			| x | 0	|  1	| 2	|
	#----------------------------------------
	# 		2			| 0 | x	|  1	| x	|
	# 		2			| 0 | x	|  x	| 1	|
	# 		2			| x | 0	|  1	| x	|
	# 		2			| x | 0	|  x	| 1	|

	li $t4, 3
	bne $s4, $t4, elsem2			#controllo: se l'indice m e' uguale a 3 sposto lo spazio (cella vuota) in alto altrimenti salto
	
	#INDICE m = 3
	j moveup
	
elsem2:
	li $t4, 2
	bne $s4, $t4, elsem1			#se l'indice m e' diverso da 2 salto
	
	#INDICE m = 2
	li $t4, 4
	bne $s3, $t4, m2a				#controllo: se mosse_disp = 4 sposto spazio in basso
	j movedown
m2a:
	beq $zero, $t3, m2b				#se up e' abilitato sposto spazio in alto
	j moveup
m2b:
	j movedown						#se invece up non e' abilitato sposto spazio in basso
	
elsem1:
	li $t4, 1
	bne $s4, $t4, elsem0			#se l'indice m e' diverso da 1 salto
	
	#INDICE m = 1
	li $t4, 4
	bne $s3, $t4, m1a				#controllo: se mosse_disp = 4 sposto spazio a sinistra
	j movesx
m1a:
	li $t4, 3
	bne $s3, $t4, m1b				#controllo se mosse_disp = 3 altrimenti salto
	beq $t2, $t3, m1c				#se i flag di down e up sono uguali(quindi entrambi abilitati) sposto in basso
									#altrimenti a sinistra
	j movesx
m1c:
	j movedown
	
m1b:								#mosse_disp = 2
	beq $zero, $t3, m1d				#se up e' abilitato sposto in alto altrimenti in basso
	j moveup	
m1d:
	j movedown

	#INDICE m = 0
elsem0:
	li $t4, 4
	bne $s3, $t4, m0a				#controllo: se mosse_disp = 4 sposto a destra altrimenti salto
	j movedx
m0a:
	li $t4, 3
	bne $s3, $t4, m0b				#controllo: se mosse_disp = 3 altrimenti salto
	beq $zero, $t0, m0c				#se dx e' abilitato sposto a destra
	j movedx
m0c:
	j movesx						#altrimenti a sinistra
	
m0b:								#mosse_disp = 2
	beq $zero, $t0, m0d				#se dx e' abilitato sposto a destra
	j movedx
m0d:								#altrimenti sposto a sinistra
	j movesx

	
movedx:
	addi $s3, $s1, 1				#$s3 = pos+1 = posizione della cella da scambiare con quella vuota
									#(mosse_disp non e' piu necessario)
	j finemossa
movesx:
	addi $s3, $s1, -1				#$s3 = pos-1 = posizione della cella da scambiare con quella vuota
	j finemossa
movedown:
	addi $s3, $s1, 4				#$s3 = pos+4 = posizione della cella da scambiare con quella vuota
	j finemossa
moveup:
	addi $s3, $s1, -4				#$s3 = pos-4 = posizione della cella da scambiare con quella vuota
finemossa:
	move $a0, $s2
	move $a1, $s1
	move $a2, $s3
	jal scambia
	
	move $v0, $s3					#viene restituita la nuova posizione della cella vuota
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	lw $s3, 12($sp)
	lw $s4, 16($sp)
	lw $ra, 20($sp)
	addi $sp, $sp, 24
	jr $ra
######################################
#procedura che scambia due celle di cui vengono fornite le posizioni
scambia:							#$a0= base address matrix
									#$a1 = posizione cella vuota
									#$a2 = posizione cella da spostare
	addi $sp, $sp, -12
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)

	move $s0, $a0
	move $s1, $a1					#$s1 = posizione cella vuota
	move $s2, $a2					#$s2 = posizione cella da spostare
	
	sll $s1, $s1, 2
	add $s1, $s0, $s1				#$s1 = address cella vuota
	sll $s2, $s2, 2
	add $s2, $s0, $s2				#$s2 = address cella da scambiare

	lw $t0, 0($s2)					#$t0 = cella da scambiare
	sw $t0, 0($s1)					#il valore della cella viene direttamente memorizzato al posto della cella vuota
	sw $zero, 0($s2)				#per spostare la cella vuota basta azzerare il valore della cella scambiata
	
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	addi $sp, $sp, 12
	jr $ra
######################################
#procedura che esegue la mossa passata come argomento e restituisce la nuova posizione della cella vuota
muovi:								#$a0 = base address matrix
									#$a1 = indice mossa
									#$a2 = posizione della cella vuota
									#$v0 = nuova posizione della cella vuota
 
	addi $sp, $sp, -20
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	sw $s2, 8($sp)
	sw $s3, 12($sp)
	sw $ra, 16($sp)
	
	move $s0, $a0
	move $s1, $a1					#$s1 = indice mossa
	move $s2, $a2					#$s2 = posizione cella vuota
	move $s3, $s2					#$s3 = posizione cella vuota(nel caso non venga eseguita alcuna mossa)
	
	li $t0, 2
	bne $s1, $t0, sinistra			#controllo se la mossa inserita e' 2 (basso) altrimenti salto
	slti $t0, $s2, 4				#$t0 = 1 se pos < 4
	bne $zero, $t0, finemuovi		#controllo: se pos < 4 la mossa 2 non puo essere eseguita quindi salto
									#se pos >= 4 la cella vuota e' spostata in alto
	addi $s3, $s2, -4				#$s3 = pos-4 (futura posizione della cella vuota e posizione della cella con cui va scambiata)
	j completamossa
	
sinistra:
	li $t0, 4
	bne $s1, $t0, destra			#controllo se la mossa inserita e' 4 (sinistra) altrimenti salto
	div $s2, $t0
	mfhi $t0						#$t0 = pos%4
	li $t1, 3 
	beq $t0, $t1, finemuovi			#controllo: se pos%4 = 3 la mossa 4 non puo essere eseguita quindi salto
									#se pos%4 != 3 la cella vuota e' spostata verso destra
	addi $s3, $s2, 1				#$s3 = pos+1 (futura posizione della cella vuota e posizione della cella con cui va scambiata)
	j completamossa
destra:
	li $t0, 6
	bne $s1, $t0, alto				#controllo se la mossa inserita e' 6 (destra) altrimenti salto
	li $t0, 4
	div $s2, $t0
	mfhi $t0						#$t0 = pos%4
	beq $zero, $t0, finemuovi		#controllo: se pos%4 = 0 la mossa 6 non puo essere eseguita
									#se pos%4 != 0 la cella vuota e' spostata verso sinistra
	addi $s3, $s2, -1				#$s3 = pos-1 (futura posizione della cella vuota e posizione della cella con cui va scambiata)
	j completamossa
alto:
	li $t0, 8
	bne $s1, $t0, finemuovi			#controllo se la mossa inserita e' 8 (alto) altrimenti non viene eseguita nessuna mossa
	slti $t0, $s2, 12				#$t0 = 1 se pos < 12 (in tal caso la mossa in alto puo' essere eseguita)
	beq $t0, $zero, finemuovi		#controllo: se $t0 = 0 (pos >= 12) la mossa 8 non puo essere eseguita
									#se $t0 = 1 la cella vuota e' spostata verso il basso
	addi $s3, $s2, 4				#$s3 = pos+4 (futura posizione della cella vuota e posizione della cella con cui va scambiata)

completamossa:
	move $a0, $s0
	move $a1, $s2
	move $a2, $s3
	jal scambia						#lo scambio avviene per mezzo di una procedura
finemuovi:
	move $v0, $s3					#la procedura restituisce la nuova posizione della cella vuota
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	lw $s2, 8($sp)
	lw $s3, 12($sp)
	lw $ra, 16($sp)
	addi $sp, $sp, 20
	jr $ra
	
######################################
#procedura che controlla se lo schema e' ordinato: nel caso restituisce 1(segnalando quindi la fine della partita) altrimenti 0
check:								#$a0 = base address matrix
									#$v0 = 1 se partita vinta 0 altrimenti
	
	addi $sp, $sp, -8
	sw $s0, 0($sp)
	sw $s1, 4($sp)
	
	move $s0, $a0
	li $v0, 1						#$v0 = 1 :lo schema e' considerato ordinato fino a prova contraria
	li $t0, 1						#$t0 = contatore celle controllate
	li $t1, 16
	
checkcella:
	beq $t1, $t0, finecheck			#se $t0 = 16 sono state controllate tutte le celle e sono corrette
	lw $s1, 0($s0)
	bne $s1, $t0, nonvinto			#se la cella analizzata ha valore diverso da quello del contatore lo schema non e' ordinato
									#il controllo non viene continuato
									
	addi $t0, $t0, 1				#incremento del contatore
	addi $s0, $s0, 4				#incremento di una word dell'indirizzo della cella analizzata
	j checkcella
nonvinto:
	li $v0, 0						#se lo schema non e' ordinato la procedura restituisce 0
finecheck:
	lw $s0, 0($sp)
	lw $s1, 4($sp)
	addi $sp, $sp, 8
	jr $ra

######################################
#procedura che stampa la classifica
printlista:							#$a0 = base address lista
	addi $sp, $sp, -4
	sw $s0, 0($sp)
	
	move $s0, $a0
	li $t0, 1						#$t0 = posizione della classifica da stampare
	li $t1, 6						#$t1 = numero totale di righe da stampare
	
	li $v0, 4						#stampa dell'intestazione della tabella
	la $a0, name
	syscall
	la $a0, point
	syscall
	la $a0, date
	syscall
	la $a0, acapo
	syscall
	
listaloop:
	li $v0, 1
	move $a0, $t0
	syscall							#stampa posizione giocatore
	li $v0, 4
	la $a0, tab
	syscall
	li $v0, 4
	move $a0, $s0
	syscall							#stampa nome giocatore
	la $a0, tab
	syscall
	addi $s0, $s0, 8
	lw $a0, 0($s0)
	li $v0, 1
	syscall							#stampa punteggio
	li $v0, 4
	la $a0, tab
	syscall
	addi $s0, $s0, 4
	move $a0, $s0
	syscall							#stampa data
	la $a0, acapo
	syscall
	addi $t0, $t0, 1				#incremento della posizione in classifica da stampare
	addi $s0, $s0, 12				#incremento dell'indirizzo per ottenere il base address della riga successiva
	bne $t0, $t1, listaloop			#se non sono state stampate tutte le righe della classifica la stampa viene ripetuta

finelista:
	lw $s0, 0($sp)
	addi $sp, $sp, 4
	jr $ra

######################################
#procedura ricorsiva che ordina la lista dalla riga i alla riga j in ordine decrescente di punteggio
ordinalista:						#$a0 = base address lista
									#$a1 = indice i della riga del primo punteggio da ordinare in classifica
									#$a2 = indice j della riga dell'ultimo punteggio da ordinare in classifica
	
	addi $sp, $sp, -24
	sw $s0, 0($sp)
	sw $ra, 4($sp)
	sw $s1, 8($sp)
	sw $s2, 12($sp)
	sw $s3, 16($sp)
	sw $s4, 20($sp)

	move $s0, $a0
	move $s1, $a1					#$s1 = i
	move $s2, $a2					#$s2 = j
	
	slt $t0, $s1, $s2
	beq $zero, $t0, fineordina		#se i>=j la procedura termina
	
	li $t0, 24						#tra una riga e l'altra della classifica vi è un offset di 24 bytes
	mul $t1, $t0, $s2
	add $t1, $s0, $t1				#$t1 = base address della riga j
	lw $s3, 8($t1)					#$s3 = punteggio salvato alla riga j = P[j]
while:
	li $t0, 24
	mul $t2, $t0, $s1
	add $t2, $s0, $t2				#$t2 = base address della riga i
	lw $s4, 8($t2)					#$s4 = punteggio salvato alla riga i = P[i]
	slt $t0, $s3, $s4
	beq $zero, $t0, finewhile
	slt $t0, $s1, $s2
	beq $zero, $t0, finewhile		#while(P[j]<P[i] && i<j)
	addi $s1, $s1, 1				#i++ (i e' incrementato fino a trovare la posizione in cui deve essere inserito il nuovo punteggio)
	j while
finewhile:
	slt $t0, $s1, $s2
	beq $zero, $t0, fineordina		#se i>=j la  classifica e' gia' ordinata e la procedura termina
	sw $s3, 8($t2)					#altrimenti i punteggi in riga i e in riga j vengono scambiati 
	sw $s4, 8($t1)
	
	lw $s3, 0($t1)					#vengono scambiati i rispettivi nomi (ciascuno di 2 bytes)
	lw $s4, 0($t2)
	sw $s3, 0($t2)
	sw $s4, 0($t1)
	lw $s3, 4($t1)
	lw $s4, 4($t2)
	sw $s3, 4($t2)	
	sw $s4, 4($t1)
	
	lw $s3, 12($t1)					#vengono scambiate le rispettive date (ciascuna di 2 bytes - il terzo viene ignorato)
	lw $s4, 12($t2)
	sw $s3, 12($t2)
	sw $s4, 12($t1)
	lw $s3, 16($t1)
	lw $s4, 16($t2)
	sw $s3, 16($t2)	
	sw $s4, 16($t1)
	
	move $a0, $s0
	addi $a1, $s1, 1
	move $a2, $s2
	jal ordinalista					#la procedura e' richiamata sulla sottolista fornendo come argomento i++

fineordina:
	lw $s0, 0($sp)
	lw $ra, 4($sp)
	lw $s1, 8($sp)
	lw $s2, 12($sp)
	lw $s3, 16($sp)
	lw $s4, 20($sp)
	addi $sp, $sp, 24
	jr $ra